From 8b9d176ea73a5ceb1db42c8b2e5660ccafc7f685 Mon Sep 17 00:00:00 2001
From: David Tolnay <dtolnay@gmail.com>
Date: Apr 26 2020 01:02:19 +0000
Subject: [PATCH 454/2232] Fix and test fallible return of Vec from C to Rust


---

diff --git a/macro/src/expand.rs b/macro/src/expand.rs
index 35603c9..d27c15c 100644
--- a/macro/src/expand.rs
+++ b/macro/src/expand.rs
@@ -281,6 +281,7 @@ fn expand_cxx_function_shim(namespace: &Namespace, efn: &ExternFn, types: &Types
                 Some(quote!(#call.map(|r| r.into_string())))
             }
             Type::RustBox(_) => Some(quote!(#call.map(|r| ::std::boxed::Box::from_raw(r)))),
+            Type::RustVec(_) => Some(quote!(#call.map(|r| r.into_vec()))),
             Type::UniquePtr(_) => Some(quote!(#call.map(|r| ::cxx::UniquePtr::from_raw(r)))),
             Type::Ref(ty) => match &ty.inner {
                 Type::Ident(ident) if ident == RustString => {
diff --git a/tests/ffi/lib.rs b/tests/ffi/lib.rs
index 0965e52..6e636d8 100644
--- a/tests/ffi/lib.rs
+++ b/tests/ffi/lib.rs
@@ -61,6 +61,7 @@ pub mod ffi {
         fn c_try_return_sliceu8(s: &[u8]) -> Result<&[u8]>;
         fn c_try_return_rust_string() -> Result<String>;
         fn c_try_return_unique_ptr_string() -> Result<UniquePtr<CxxString>>;
+        fn c_try_return_rust_vec() -> Result<Vec<u8>>;
 
         fn get(self: &C) -> usize;
         fn set(self: &mut C, n: usize) -> usize;
diff --git a/tests/ffi/tests.cc b/tests/ffi/tests.cc
index 7867bf0..8ea3d06 100644
--- a/tests/ffi/tests.cc
+++ b/tests/ffi/tests.cc
@@ -223,6 +223,10 @@ std::unique_ptr<std::string> c_try_return_unique_ptr_string() {
   return c_return_unique_ptr_string();
 }
 
+rust::Vec<uint8_t> c_try_return_rust_vec() {
+  throw std::runtime_error("unimplemented");
+}
+
 extern "C" C *cxx_test_suite_get_unique_ptr() noexcept {
   return std::unique_ptr<C>(new C{2020}).release();
 }
diff --git a/tests/ffi/tests.h b/tests/ffi/tests.h
index 9a067d2..22fed58 100644
--- a/tests/ffi/tests.h
+++ b/tests/ffi/tests.h
@@ -65,5 +65,6 @@ rust::Str c_try_return_str(rust::Str);
 rust::Slice<uint8_t> c_try_return_sliceu8(rust::Slice<uint8_t>);
 rust::String c_try_return_rust_string();
 std::unique_ptr<std::string> c_try_return_unique_ptr_string();
+rust::Vec<uint8_t> c_try_return_rust_vec();
 
 } // namespace tests

